package com.examples.ffmpeg4android_demo;

import com.netcompss.ffmpeg4android_client.BaseWizard;
import com.netcompss.ffmpeg4android_client.Prefs;
import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;

public class DemoClient extends BaseWizard {
	

	
	@Override
	  public void onCreate(Bundle savedInstanceState) {
	      super.onCreate(savedInstanceState);
 
	      setDemoFolder(Environment.getExternalStorageDirectory().getAbsolutePath() + "/videokit/");
	      
	      // this will copy the license file and the demo video file.
	      // to the work folder and the demo folder locations.
	      copyLicenseFromAssetsToWorkFolderIfNeeded();
	      copyDemoFilesFromAssetsToSDIfNeeded();

	      setContentView(R.layout.ffmpeg_demo_client);
	      
	      Button invoke =  (Button)findViewById(R.id.invokeButton);
	      invoke.setOnClickListener(new OnClickListener() {
				public void onClick(View v){
					EditText commandText = (EditText)findViewById(R.id.CommandText);
				
					////////////////////////////////////////////////////////////
					// you must use setCommand or setCommandComplex methods
					String commandStr = commandText.getText().toString();
					//String commandStr = "ffmpeg -y -i /sdcard/videokit/sample.mp4 -strict experimental -s 160x120 -aspect 4:3 -r 30 -ab 48000 -ac 2 -ar 22050 -b 150k -vcodec mpeg4 /sdcard/videokit/out.mp4";
					setCommand(commandStr);
					
					//String[] complexCommand = {"ffmpeg","-y" ,"-i", "/sdcard/videokit/in.mp4","-strict","experimental","-s", "160x120","-r","25", "-vcodec", "mpeg4", "-b", "150k", "-ab","48000", "-ac", "2", "-ar", "22050", "/sdcard/videokit/out.mp4"};
					//setCommandComplex(complexCommand);
					////////////////////////////////////////////////////////////
					

					////////optional///////////////
					// If the output file is not set, the notification will not contain
					// the video play, and the video will not be added to the gallery.
					setOutputFilePath("/sdcard/videokit/out.mp4");
					
					setProgressDialogTitle("Exporting As MP4 Video");
					setProgressDialogMessage("Depends on your video size, it can take a few minutes");
					setNotificationIcon(R.drawable.icon2);
					setNotificationMessage("Demo is running...");
					setNotificationTitle("Demo Client");
					setNotificationfinishedMessageTitle("Demo Transcoding finished");
					setNotificationfinishedMessageDesc("Click to play demo");
					setNotificationStoppedMessage("Demo Transcoding stopped");
					///////////////

					Log.i(Prefs.TAG, "ffmpeg4android library version: " + Prefs.getLibraryVersionName());
					runTranscoing();
					/////////////////////////////////
				}
			});
	      
	      Button showLog =  (Button)findViewById(R.id.showLastRunLogButton);
	      showLog.setOnClickListener(new OnClickListener() {
				public void onClick(View v){
					startAct(com.netcompss.ffmpeg4android_client.ShowFileAct.class);				
				}
			});
    
	}
	
	@Override
	public void onBackPressed() {
		super.onBackPressed();
		Log.i(Prefs.TAG, "onBackPressed called");
		stopTranscoding();
	}
	
	/**
	 * callback method, will be called from ffmpeg4android library when the transcoding finished
	 */
	public void transcodingFinished() {
		Log.i(Prefs.TAG, "transcodingFinished() from demo client");
		
	}

}
